<script setup lang="ts">
import {useWeatherStore} from "@/stores/weather";
import {ref} from "vue";

const store = useWeatherStore();
const isActive = ref(false);
const buttonText = ref("Select Location");

function toggleDropDown() {
  isActive.value = !isActive.value;
}

function getWeatherByLocation(locShorthand: string | null) {
  const locations = {
    MU: "München",
    BE: "Berlin",
    WI: "Wiesbaden",
  };

  if (typeof locShorthand === "string")
    buttonText.value = locations[locShorthand as keyof Object];
  store.getWeatherData(locShorthand);
}
</script>

<template>
  <section class="app--location grid grid-cols-2 gap-10 shadow-xl rounded-md p-5 bg-gray-800">
    <form class="w-full max-w-lg">
      <div class="flex flex-wrap -mx-3 mb-6">
        <div class="w-full md:w-1/2 px-3 mb-6 md:mb-0">
          <label class="block uppercase tracking-wide text-xs font-bold mb-2"
                 for="grid-first-name">
            Latitude
          </label>
          <input class="appearance-none block w-full bg-gray-200 text-gray-700 border border-gray-200
                        rounded py-3 px-4 leading-tight focus:outline-none focus:bg-white"
                 type="text"
                 placeholder="Jane"
                 v-model="store.location.lat"/>
          <p class="text-red-500 text-xs italic mt-2"
             :class="{ hidden: store.isValid }">
            Please fill out this field.
          </p>
        </div>
        <div class="w-full md:w-1/2 px-3">
          <label class="block uppercase tracking-wide text-xs font-bold mb-2"
                 for="grid-last-name">
            Longitude
          </label>
          <input class="appearance-none block w-full bg-gray-200 text-gray-700 border border-gray-200 rounded py-3 px-4
                        leading-tight focus:outline-none focus:bg-white focus:border-gray-500"
                 type="text"
                 placeholder="Doe"
                 v-model="store.location.lon"/>
          <p class="text-red-500 text-xs italic mt-2"
             :class="{ hidden: store.isValid }">
            Please fill out this field.
          </p>
        </div>
      </div>
      <button type="button"
              @click="getWeatherByLocation(null)"
              class="bg-transparent hover:bg-main font-semibold py-2 px-4 border border-white rounded"
              :disabled="!store.isValid ? '' : disabled">
        Get Weather
      </button>
    </form>

    <div class="pt-5">
      <button id="dropdownDefaultButton"
              data-dropdown-toggle="dropdown"
              @click="toggleDropDown()"
              class="h-12 text-white bg-blue-700 hover:bg-blue-800 focus:ring-4 focus:outline-none
                     focus:ring-blue-300 font-medium rounded-lg text-sm px-5 py-2.5 text-center inline-flex
                     items-center dark:bg-blue-600 dark:hover:bg-blue-700 dark:focus:ring-blue-800"
              type="button">
        {{ buttonText }}
        <svg class="w-2.5 h-2.5 ml-2.5"
             aria-hidden="true"
             xmlns="http://www.w3.org/2000/svg"
             fill="none"
             viewBox="0 0 10 6">
          <path stroke="currentColor"
                stroke-linecap="round"
                stroke-linejoin="round"
                stroke-width="2"
                d="m1 1 4 4 4-4"/>
        </svg>
      </button>

      <div id="dropdown"
           class="z-10 bg-white divide-y divide-gray-100 rounded-lg shadow w-44 dark:bg-gray-700"
           :class="{ hidden: !isActive }">
        <ul class="py-2 text-sm text-gray-700 dark:text-gray-200"
            aria-labelledby="dropdownDefaultButton">
          <li>
            <a @click="getWeatherByLocation('BE')"
               class="block px-4 py-2 hover:bg-gray-100 dark:hover:bg-gray-600 dark:hover:text-white"
            >Berlin</a>
          </li>
          <li>
            <a @click="getWeatherByLocation('WI')"
               class="block px-4 py-2 hover:bg-gray-100 dark:hover:bg-gray-600 dark:hover:text-white"
            >Wiesbaden</a>
          </li>
          <li>
            <a @click="getWeatherByLocation('MU')"
               class="block px-4 py-2 hover:bg-gray-100 dark:hover:bg-gray-600 dark:hover:text-white"
            >München</a>
          </li>
        </ul>
      </div>
    </div>
  </section>
</template>
